/*
第一季：集合(一)
	Java基础视频教程第14天-05-集合框架(ListIterator)

为什么要有ListIterator?
	在迭代时，如果通过集合对象的方法操作集合中的元素，发生ConcurrentModificationException异常，
	所以，在迭代时，只能用迭代器的放过操作元素。可是Iterator方法是有限的，只能对元素进行判断，取出，删除的操作，
	如果想要其他的操作如添加，修改等，就需要使用其子接口，ListIterator。

	
ListIterator
	
	这是相对更加特殊的一个接口，只用于List集合，可以完成逆序输出。(可以逆向遍历数据，但是需要先正向遍历。)
		boolean hasPrevious():返回该迭代器关联集合是否还有上一个元素；
		Object previous():返回该迭代器的上一个元素；
	
	ListIterator迭代器不仅可以对迭代器进行获取和删除，还可以对迭代器进行添加和修改。 
		void remove():从列表中移除由 next 或 previous 返回的最后一个元素。 
		void set(E e):用指定元素替换 next 或 previous 返回的最后一个元素。
*/

//EG:	列表迭代器
class ListIteratorDemo
{

	public static void sop(Object obj)
	{
		System.out.println(obj);
	}
	public static void main(String[] args) 
	{
		ArrayList al = new ArrayList();
		al.add("java01");
		al.add("java02");
		al.add("java03");
		
		ListIterator li = al.listIterator();
		while(li.hasNext())
		{
			Object obj = li.next();
			if(obj.equals("java02"))
				//li.add("java009");
				li.set("java006");
		}

		while(li.hasPrevious())
		{
			sop("pre::"+li.previous());
		}
		sop(al);

		/*
		//在迭代过程中，准备添加或者删除元素。

		Iterator it = al.iterator();
		while(it.hasNext())
		{
			Object obj = it.next();

			if(obj.equals("java02"))
				//al.add("java008");
				it.remove();//将java02的引用从集合中删除了。
			sop("obj="+obj);
		}
		sop(al);
		*/
	}
}
