 /*
第一季：集合(一)
	Java基础视频教程第14天-08-集合框架(LinkedList)
	Java基础视频教程第14天-09-集合框架(LinkedList练习)
	
Collection：
	|------List（列表）：有序，可重复。	
		|--LinkedList：底层是链表数据结构，查询很慢，增删速度很快。（线程不同步）
		
LinkedList特有方法：
增：
	 addFirst(E e)
		将指定元素插入此列表的开头。
	 addLast(E e)
		将指定元素添加到此列表的结尾。

在JDK1.6出现了替代方法-->
	offer(E e)
        将指定元素添加到此列表的末尾（最后一个元素）。 
	boolean  offerFirst(E e)
		在此列表的开头插入指定的元素。  
	boolean  offerLast(E e)
		在此列表末尾插入指定的元素。  

获取：
	(1)获取并删除：
	E  removeFirst()
		移除并返回此列表的第一个元素。
	E  removeLast()
		移除并返回此列表的最后一个元素。  
	注：获取元素，但是元素被删除。如果集合中没有元素，会出现NoSuchElementException

在JDK1.6出现了替代方法-->
	E  poll()
		获取并移除此列表的头（第一个元素）  
	E  pollFirst()
		获取并移除此列表的第一个元素；如果此列表为空，则返回 null。  
	E  pollLast()
		获取并移除此列表的最后一个元素；如果此列表为空，则返回 null。 

	(2)获取但不删除
	E  element()
		获取但不移除此列表的头（第一个元素）。
		
	E  getFirst()
		返回此列表的第一个元素。  
	E  getLast()
		返回此列表的最后一个元素。  
	注：获取元素，但不删除元素。如果集合中没有元素，会出现NoSuchElementException

在JDK1.6出现了替代方法-->
	E  peek()
		获取但不移除此列表的头（第一个元素）。  
	E  peekFirst()
		获取但不移除此列表的第一个元素；如果此列表为空，则返回 null。  
	E  peekLast()
		获取但不移除此列表的最后一个元素；如果此列表为空，则返回 null。  

插入：
	boolean  offerFirst(E e)
		在此列表的开头插入指定的元素。 
	boolean  offerLast(E e)
		在此列表末尾插入指定的元素。 
*/

//eg:           copy 毕老师

class LinkedListDemo 
{
	public static void main(String[] args) 
	{
		LinkedList link = new LinkedList();

		link.addLast("java01");
		link.addLast("java02");
		link.addLast("java03");
		link.addLast("java04");

		//sop(link);
//		sop(link.getFirst());
//		sop(link.getFirst());
		//sop(link.getLast());
		//sop(link.removeFirst());
		//sop(link.removeFirst());

		//sop("size="+link.size());

		while(!link.isEmpty())
		{
			sop(link.removeLast());
		}

	}

	public static void sop(Object obj)
	{
		System.out.println(obj);
	}
}






/*
使用LinkedList模拟一个堆栈或者队列数据结构。

堆栈：先进后出  如同一个杯子。
队列：先进先出 First in First out  FIFO 如同一个水管。



*/

import java.util.*;
class DuiLie
{
	private LinkedList link;

	DuiLie()
	{
		link = new LinkedList();
	}
	
	public void myAdd(Object obj)
	{
		link.addFirst(obj);
	}
	public Object myGet()
	{
		return link.removeFirst();
	}
	public boolean isNull()
	{
		return link.isEmpty();
	}

}



class  LinkedListTest
{
	public static void main(String[] args) 
	{
		DuiLie dl = new DuiLie();
		dl.myAdd("java01");
		dl.myAdd("java02");
		dl.myAdd("java03");
		dl.myAdd("java04");

		while(!dl.isNull())
		{
			System.out.println(dl.myGet());
		}
	}
}


















